VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "   GridGame"
   ClientHeight    =   5940
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5340
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5940
   ScaleWidth      =   5340
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmd_Start 
      Caption         =   " "
      Height          =   375
      Left            =   3480
      TabIndex        =   2
      Top             =   5400
      Width           =   1695
   End
   Begin VB.PictureBox pct_Main 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      ForeColor       =   &H80000008&
      Height          =   5040
      Left            =   120
      ScaleHeight     =   5010
      ScaleWidth      =   5010
      TabIndex        =   1
      Top             =   120
      Width           =   5040
   End
   Begin VB.PictureBox pct_Fon 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   315
      Left            =   5520
      Picture         =   "frmMain.frx":0000
      ScaleHeight     =   315
      ScaleWidth      =   1260
      TabIndex        =   0
      Top             =   240
      Width           =   1260
   End
   Begin VB.Label lbl_Counter 
      AutoSize        =   -1  'True
      Caption         =   "0"
      Height          =   195
      Left            =   1440
      TabIndex        =   4
      Top             =   5280
      Width           =   90
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   ". :"
      Height          =   195
      Left            =   120
      TabIndex        =   3
      Top             =   5280
      Width           =   1215
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const SIZE_BOX As Long = 315

Private Enum E_Cell_Orientation
    C_UP = 1    '  
    C_RIGHT = 2 '  
    C_DOWN = 3  ' 
    C_LEFT = 4  ' 
End Enum

Private Type E_Cell
    X As Long
    Y As Long
End Type

Private Area(16, 16) As E_Cell_Orientation

Private flg_Start As Boolean

Private Counter As Long

Private m_Moving() As E_Cell

'  ()
Private Function Rand_Area()
    Dim I As Long, J As Long
    Randomize Timer
    For I = 1 To 16
        For J = 1 To 16
            Area(I, J) = Int(Rnd * 4) + 1
        Next
    Next
End Function

'.  
Private Function Fill_Art_Area()
    Dim I As Long, J As Long
    pct_Main.Cls
    For I = 1 To 16
        For J = 1 To 16
            pct_Main.PaintPicture pct_Fon, (I - 1) * SIZE_BOX, (J - 1) * SIZE_BOX, SIZE_BOX, SIZE_BOX, Area(I, J) * SIZE_BOX - SIZE_BOX, 0, SIZE_BOX, SIZE_BOX
        Next
    Next
End Function

' 
Private Function Start_Game()
    ReDim m_Moving(0)

    Rand_Area
    Fill_Art_Area
    
    flg_Start = False
    Counter = 0
    lbl_Counter.Caption = Counter
End Function

'  
Private Sub cmd_Start_Click()
    Start_Game
End Sub

' 
Private Sub Form_Load()
    cmd_Start_Click
End Sub

'  
Private Sub pct_Main_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim mx As Long, my As Long
    mx = X \ SIZE_BOX + 1
    my = Y \ SIZE_BOX + 1
    
    If flg_Start = False Then
        '   
        flg_Start = True
        
        Small_Rotate mx, my, Area
        Check_Mate mx, my, Area
        Fill_Art_Area

        lbl_Counter.Caption = Counter
        
    End If
End Sub

'  
Private Function Small_Rotate(X As Long, Y As Long, m_out() As E_Cell_Orientation)
    ReDim Preserve m_Moving(UBound(m_Moving) + 1)
    
    m_Moving(UBound(m_Moving)).X = X
    m_Moving(UBound(m_Moving)).Y = Y
    
    m_out(X, Y) = m_out(X, Y) + 1
    If m_out(X, Y) = 5 Then m_out(X, Y) = 1
    Counter = Counter + 1
End Function

' 
Private Function Check_Mate(X As Long, Y As Long, m_out() As E_Cell_Orientation)
    Dim flg As Boolean
    Select Case Area(X, Y)
        '
        Case 1
            If X <> 1 Then
            '  
                If Area(X - 1, Y) = 3 Or Area(X - 1, Y) = 4 Then
                    Small_Rotate X - 1, Y, m_out
                    Check_Mate X - 1, Y, m_out
                End If
            End If
            If Y <> 16 Then
            ' 
                If Area(X, Y + 1) = 2 Or Area(X, Y + 1) = 3 Then
                    Small_Rotate X, Y + 1, m_out
                    Check_Mate X, Y + 1, m_out
                End If
            End If
        '
        Case 2
            If X <> 1 Then
            '  
                If Area(X - 1, Y) = 3 Or Area(X - 1, Y) = 4 Then
                    Small_Rotate X - 1, Y, m_out
                    Check_Mate X - 1, Y, m_out
                End If
            End If
            If Y <> 1 Then
            ' 
                If Area(X, Y - 1) = 1 Or Area(X, Y - 1) = 4 Then
                    Small_Rotate X, Y - 1, m_out
                    Check_Mate X, Y - 1, m_out
                End If
            End If
        '
        Case 3
            If X <> 16 Then
            '  
                If Area(X + 1, Y) = 1 Or Area(X + 1, Y) = 2 Then
                    Small_Rotate X + 1, Y, m_out
                    Check_Mate X + 1, Y, m_out
                End If
            End If
            If Y <> 1 Then
            ' 
                If Area(X, Y - 1) = 1 Or Area(X, Y - 1) = 4 Then
                    Small_Rotate X, Y - 1, m_out
                    Check_Mate X, Y - 1, m_out
                End If
            End If
        '
        Case 4
            If X <> 16 Then
            '  
                If Area(X + 1, Y) = 1 Or Area(X + 1, Y) = 2 Then
                    Small_Rotate X + 1, Y, m_out
                    Check_Mate X + 1, Y, m_out
                End If
            End If
            If Y <> 16 Then
            ' 
                If Area(X, Y + 1) = 2 Or Area(X, Y + 1) = 3 Then
                    Small_Rotate X, Y + 1, m_out
                    Check_Mate X, Y + 1, m_out
                End If
            End If
    End Select
End Function

